#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


#define NORTHWEST	1
#define NORTH 		2
#define NORTHEAST 	3
#define WEST		4 
#define EAST		5
#define SOUTHWEST	6
#define SOUTH		7
#define SOUTHEAST	8

#define POSSIBLE_EDGE	0
#define EDGE			'1'
#define NON_EDGE		'0'


	
struct _link{
   //point p;
   int index;
   struct _link *next;
};

typedef struct _link link;
	
typedef struct _label{
   int l;
   link *list;
}label;


typedef struct _header{
	char *type;
	int width;
	int height;
	int maxGreyVal;
}header;

typedef struct _point{
	double x;
	double y;
	double z;
}point;


char displayMenu();
FILE *getFileName();
char *trim(char *);
double dist(int, int, point*);
header* readHeader();
char* readWord();
double readNumber(FILE *);
int readIntNumber(FILE *);

double distance( point *, point * ); 
point cluster(int,int ); /* main algorithm: receives an index and returns the cluster center point*/
void writeSmoothData();
void writeEdges();
void computeGradient(short **gradData, short **smoothData);
double sqr( double x );
void initializeImageData();
void initializeImageDataNoFactoring();
char getChar();
char *getString(char *comment);
void computeEdges(short **);
//void setBitData( int i, int j, int flag, short **data, int direction );
void followEdges(int i, int j, short** data);
link *addIndex( int index, link *list );
void changeAllIndices( int changeTo, link *, label * );
void sumPoint( point *, point *, int, int );
short **segmentImage( short **imageData);
point devidePoint( int count, point p);


int height,width;
short **imageData;
short **smoothData;
short **gradData;
char **bitData;

int n;
double factor;
//link* head = NULL;
double h = 10; 		/* try different values as well */
double threshold = 0.01; 	/* stopping condition for the iterations */
int t2 = 25;		/* thresold for clustering links */
int t1 = 17; // huh?
double segT = 1;

FILE *fd;
header *hdr;
	
